/**
 * 
 */
var mX=0,mY=0;

var statements=[];
var divHoveringIndex=-1;
var divSrcIndex=-1;
var divDestinationIndex=-1;
var xOffset=0;
var yOffset=0;
var slotHeight=0;
var originalStatementLeft=0;
var originalStatementTop=0;
var entryID=0;
var explanationTitle="";
var useNOT=false;

var effectRunning=false;

function initialise(){
    initialiseToggleButton();
    var leftBorder=10;
    showAppTitle();
    initialiseEvents();
    showPrompt(false);

    codeLeftBorder=$(document).width()/2+verticalBorder;
    codeTopBorder=$(document).height()/2;
    listLeft=leftBorder;
    listTop=$("#mainArea").position().top;
    defineMovablesArray();
    generateNewExpression();
    placeDIVs();
    initialiseEvents();
}

function initialiseToggleButton(){
    var toggleBtn="<input id='logicalSwitch' class='tgl tglFlip' type='checkbox'/>";
    toggleBtn+="<label class='tglBtn' data-tgOff='Ψευδής' data-tgOn='Αληθής' for='logicalSwitch'></label>";

    $("#myLi").html(toggleBtn);
}

function initialiseEvents(){
    // touch events
    $("#showInfo").on("touchend",function(evt){
        $("#showInfo").trigger("click");
    });

    $("#list0").on("click tap touchstart touchend",function(evt){
        $(".itemToExplain").removeClass("itemToExplain");
        if(evt.target.id=="list0"){
            $("#list1").hide(animationRate);
        }
        else{
            handleTappedList(evt.target.id);
        }
        showListPrompt();
        evt.stopImmediatePropagation();
    });

    $("#assignmentToCheck0").on("touchend",function(evt){
        evt.preventDefault();
        evt.stopImmediatePropagation();
        $(".itemToExplain").removeClass("itemToExplain");

        $("#list"+wrongListIndex).css({
            "background-color":"#ffffff"
        });
        $("#list"+correctListIndex).css({
            "background-color":"#ffffff"
        });
        divSrcIndex=0;
        $("#"+statements[divSrcIndex].htmlID).addClass("tapped");
    });

    $("#btnCheckAnswer").on("click tap touchstart",function(evt){
        evt.stopImmediatePropagation();
        //var userAnswer=$("#userAnswer").val();
        var userAnswer=logicalToGreek($("#logicalSwitch").is(':checked'));
        if(userAnswer=="") userAnswer="0";
        var originalRslt=logicalToGreek($("#assignmentToCategorise").attr("data-result"));
        var newClass="categorisationOk";
        explanationTitle="Ορθή αποτίμηση";
        if(userAnswer!=originalRslt){
            newClass="categorisationError";
            explanationTitle="Λανθασμένη αποτίμηση";
        }
        var itemToAdd=$("#assignmentToCategorise").html()+" ⇔  "+userAnswer;
        var explanation=$("#assignmentToCategorise").attr("data-explanation");
        var htmlToAdd="<code class='"+newClass+"' id='entry"+entryID+"' data-explTitle='"+explanationTitle+"' data-explanation='"+explanation+"'>"+itemToAdd+"</code><br>";
        var currentList=$("#list0").html();
        $("#list0").html(htmlToAdd+currentList);
        var scoreToShow=calculateScore(0);
        $("#score0").html(scoreToShow);
        generateNewExpression();
        showListPrompt();
    });
    
    $("#btnRefresh").on("click tap touchstart",function(evt){
        //evt.preventDefault();
        evt.stopImmediatePropagation();
        generateNewExpression();
    });
}

function handleTappedList(targetID){
    $("#"+targetID).addClass("itemToExplain");
    var param=$("#"+targetID).attr("data-explanation");
    $("#list1").show(animationRate);
    showExplanation(param);
}

function calculateScore(selectedList){
    var correctEntries=$("#list"+selectedList+" .categorisationOk").length;
    var totalEntries=correctEntries+$("#list"+selectedList+" .categorisationError").length;
    var percentage=parseInt(1000*correctEntries/totalEntries)/10;
    return ": "+correctEntries+"/"+totalEntries+" ("+percentage+"%)";
}

function showListPrompt(){
    var correctEntries=$("#list0 .categorisationOk").length;
    var totalEntries=correctEntries+$("#list0 .categorisationError").length;
    if($(".itemToExplain").length>0){
        $("#explain").html($(".itemToExplain").attr("data-explTitle"));
    }
    else if(totalEntries){
        $("#explain").html("Επιλέξτε μια καταχώρηση από τη λίστα για επεξήγηση του αποτελέσματος.");
    }
}

function showExplanation(explanation){
    $("#list1").html("<code>"+explanation+"</code>");
}

function defineMovablesArray(){
    var page=0,col=0,row=0;
    $.each($(".movableDIV"),function(){
        var height=parseInt($(this).outerHeight());
        slotHeight=Math.max(slotHeight,height);
    });
    var i=0;
    $.each($(".movableDIV"),function(){
        var htmlID=$(this).attr("id");
        originalStatementLeft=($(document).width()-$("#assignmentToCheck0").width())/2;
        originalStatementTop=$("#promptArea").position().top+$("#promptArea").height()+verticalBorder;
        var width=$("#assignmentToCheck0").width();
        var newStatement=new statement(htmlID,codeLeftBorder,codeTopBorder,originalStatementLeft,originalStatementTop,row,col,width,slotHeight,page,animationRate);
        statements.push(newStatement);
        row++;
        i++;
    });
    placeDIVs();
}

function generateNewExpression(){
    entryID++;
    var explanation="";

    var expressionLeftResults=generateComparativeExpression();
    var expressionLeft=expressionLeftResults.newValue;
    var expressionLeftSteps=expressionLeftResults.expressionSteps;
    var decimalsPresent=expressionLeftResults.decimalsPresent;
    var fullExpression=expressionLeft;
    var finalResult;
    if(Math.random()<0.5){
        var expressionRightResults=generateComparativeExpression();
        var expressionRight=expressionRightResults.newValue;
        var expressionRightSteps=expressionRightResults.expressionSteps;
        decimalsPresent=decimalsPresent || expressionRightResults.decimalsPresent;
        var slctdLogicOperator=" "+logicalOperators[parseInt(Math.random()*(logicalOperators.length-1))]+" ";
        fullExpression+=slctdLogicOperator+expressionRight;
        progressiveExpression=[];
        finalResult=stringLogicalValue(fullExpression,[],[],true);
        progressiveExpression=generateFullProgressiveExpression(expressionLeftSteps,slctdLogicOperator,expressionRightSteps,"","");

        finalResult=logicalToGreek(finalResult);
        progressiveExpression.push(finalResult);
    }
    else{
        progressiveExpression=[];
        if(useNOT){
            finalResult=stringLogicalValue(fullExpression,[],[],true);
        }
        else{
            finalResult=stringComparativeValue(fullExpression,[],[],true);
        }
        progressiveExpression=expressionLeftSteps;
    }
    explanation=getProgressiveExpression();
    showPrompt(decimalsPresent);
    $("#assignmentToCategorise").html(fullExpression);
    $("#assignmentToCategorise").attr("data-result",finalResult);
    $("#assignmentToCategorise").attr("data-explanation",explanation);
}

function logicalToGreek(result){
    if(result==true || result=="ΑΛΗΘΗΣ" || result=="true"){
        result="ΑΛΗΘΗΣ";
    }
    else{
        result="ΨΕΥΔΗΣ";
    }
    return result;
}

function generateComparativeExpression(){
    var decimalsPresent=false;
    var leftAddendum="";
    var rightAddendum="";
    useNOT=Math.random()>0.8;
    if(useNOT){
        leftAddendum="ΟΧΙ (";
        rightAddendum=")";
    }

    var newValue1=generateArithmeticExpression(100,1,noOfArithmeticOperators,noOfIntegerFunctions);
    progressiveExpression=[];
    var result1=stringExpressionValue(newValue1,[],[],"","",true);
    decimalsPresent=result1!=parseInt(result1);
    progressiveExpression.push(result1);
    var progrExpr1=progressiveExpression;
    
    var newValue2=generateArithmeticExpression(100,1,noOfArithmeticOperators,noOfIntegerFunctions);
    progressiveExpression=[];
    var result2=stringExpressionValue(newValue2,[],[],"","",true);
    decimalsPresent=decimalsPresent || result2!=parseInt(result2);
    progressiveExpression.push(result2);
    var progrExpr2=progressiveExpression;
    

    var comparator=" "+comparators[parseInt(Math.random()*comparators.length)]+" ";
    var expressionSteps=generateFullProgressiveExpression(progrExpr1,comparator,progrExpr2,leftAddendum,rightAddendum);
    
    var newValue=leftAddendum+newValue1+comparator+newValue2+rightAddendum;
    progressiveExpression=[];
    var result="";
    if(useNOT){
        result=stringLogicalValue(newValue,[],[],"","",true);
    }
    else{
        result=stringComparativeValue(newValue,[],[],"","",true);
    }
    result=logicalToGreek(result);
    expressionSteps.push(result);
    
    return{
        newValue: newValue,
        expressionSteps: expressionSteps,
        decimalsPresent: decimalsPresent
    };
}

function generateArithmeticExpression(factor1,factor2,permittedOperators,permittedFunctions){
    var operatorSelector=-1;
    var previousOperatorSelector=-1;
    var selectedOperator="";
    var operatorsToExclude=[];
    var excludingOperator=false;

    var functionSelector=-1;
    var selectedFunction="";
    var newValue="";
    
    var multiplicity=parseInt(Math.random()*(currentNoOfOperands-minNoOfOperands))+minNoOfOperands;//το πολύ maxNoOfOperands ορίσματα
    var newNumber=0;
    var includeFunction=false;
    var includeParenthesis=false;
    var parenthesisOpenPos=-1;
    var parenthesisClosePos=-1;
    if(multiplicity>4){
        includeParenthesis=Math.random()<1.4;
        if(includeParenthesis){
            parenthesisOpenPos=parseInt(Math.random()*3);
            var attempts=0;
            do{
                attempts++;
                parenthesisClosePos=parseInt(Math.random()*(multiplicity-parenthesisOpenPos)+parenthesisOpenPos);
            }while(attempts<80 && (parenthesisClosePos-parenthesisOpenPos<2 || parenthesisClosePos==multiplicity-1));
        }
    }
    for(var i=0;i<multiplicity;i++){
        if(i==parenthesisOpenPos){
            if(selectedOperator==" ^ "){
                parenthesisClosePos=-1;
            }
            else{
                newValue+="(";
            }
        }
        includeFunction=Math.random()<0.1;//10% πιθανότητα να χρησιμοποιηθεί συνάρτηση
        if(includeFunction){
            functionSelector=parseInt(Math.random()*permittedFunctions);
            selectedFunction=functions[functionSelector];
            newValue+=selectedFunction+"(";
        }
        /*else{//στο υπόλοιπο 90% χρησιμοποιείται παρένθεση με ...
            includeParenthesis=Math.random()<0.4;//...πιθανότητα 40%
            if(includeParenthesis){
                newValue+="(";
            }
        }*/

        if(selectedOperator==" ^ "){
            newNumber=2;
        }
        else if(selectedOperator==" * " || selectedOperator==" / " || selectedOperator==" DIV " || selectedOperator==" MOD "){
            newNumber=parseInt(Math.random()*8+2);//αποκλεισμός της τιμής 1 ως δεύτερος όρος πολλαπλασιασμού ή διαίρεσης
        }
        else{
            newNumber=parseInt(Math.random()*9+1);
        }
        if(selectedFunction=="Τ_Ρ"){
            newNumber=Math.pow(Math.abs(newNumber),2);
        }
        else if(selectedFunction=="Α_Τ"){
            newNumber=-Math.abs(newNumber);
        }
        else if(selectedFunction=="Α_Μ"){
            newNumber=parseInt(Math.random()*100+1)/10+1;
        }

        newValue+=newNumber;
        if(includeFunction){
            newValue+=")";
            selectedFunction="";
        }
        if(i==parenthesisClosePos){
            newValue+=")";
        }
        if(i<multiplicity-1){
            do{//παραγωγή αριθμητικού τελεστή
                operatorSelector=parseInt(Math.random()*permittedOperators);
                selectedOperator=arithmeticOperators[operatorSelector];
                excludingOperator=false;
                var j=0;
                while(j<operatorsToExclude.length && !excludingOperator){
                    if(selectedOperator==operatorsToExclude[j]){
                        excludingOperator=true;
                    }
                    else{
                        j++;
                    }
                }
            }while(excludingOperator || operatorSelector==previousOperatorSelector);
            previousOperatorSelector=operatorSelector;
            newValue+=selectedOperator;
            if(selectedOperator==" / "){
                operatorsToExclude=[" DIV "," MOD "];
            }
            else if(selectedOperator==" DIV " || selectedOperator==" MOD "){
                operatorsToExclude=[" / "];
            }
        }
    }
    return newValue;
}

function placeDIVs(){
    $("#expressionValuePairs").css({
        left:listLeft,
        top:listTop
    });
    $("#expressionValuePairs").width($(document).width()-2*listLeft);
    $("#list0").width($("#expressionValuePairs").innerWidth()-2*listLeft);
    $("#list1").width($("#expressionValuePairs").innerWidth()-2*listLeft);
    showStatements();
    $("#controls").css({
        left:($(document).width()-$("#controls").width())/2,
        top:listTop-50
    });
}

function showStatements(){
    for( var i=0;i<statements.length;i++){
        $("#assignmentToCheck"+i).show();
        statements[i].move(originalStatementLeft,originalStatementTop);
    }
}

function showPrompt(decimals){
    var additional="";
    if(decimals){
        additional=" Χρησιμοποιήστε προσέγγιση δύο δεκαδικών ψηφίων για τον υπολογισμό των πηλίκων.";
    }
    var msg="Η ακόλουθη έκφραση είναι ΑΛΗΘΗΣ ή ΨΕΥΔΗΣ;"+additional;
    $("#prompt").html(msg);
}